Index: /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/LIM_SRC_2/limthd_zdf_2.F90
===================================================================
--- /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/LIM_SRC_2/limthd_zdf_2.F90	(revision 1854)
+++ /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/LIM_SRC_2/limthd_zdf_2.F90	(revision 1855)
@@ -402,58 +395,58 @@
 !$$$             &         - zumsb * ( zkhsn * tbif_1d(ji,1)
 !$$$             &                   + zkhsnint * ( tbif_1d(ji,1) - tbif_1d(ji,2) ) ) )
-          zsmbr(1) = zidsn(ji) * sist_1d(ji) + z1midsn(ji) *    &
-             &       ( h_snow_1d(ji) * tbif_1d(ji,1) - ( zfcsudt(ji) / rcpsn )  &
-             &       - zumsb * zkhsnint * ( tbif_1d(ji,1) - tbif_1d(ji,2) ) )
-
-          zsmbr(2) =  tbif_1d(ji,2)  &
-             &      - zidsn(ji) * ( 1.0 - zidsnic(ji) ) &
-             &        * ( zfcsudt(ji) / MAX( h_ice_1d(ji) * rcpic , epsi20 ) ) &
-             &      + zumsb * ( zkhicint * ( tbif_1d(ji,1) - tbif_1d(ji,2) ) &
-             &                   - zkhic * ( tbif_1d(ji,2) - tbif_1d(ji,3) )  )
-
-          zsmbr(3) =  tbif_1d(ji,3)  &
-             &      + zkhic * ( 2.0 * tfu_1d(ji) &
-             &                + zumsb * ( tbif_1d(ji,2) - 3.0 * tbif_1d(ji,3) ) )
-          
-          !     6.4. Solve the system (Gauss elimination method).
-          !----------------------------------------------------
-          
-          zpiv1 = zsubdiag(2) / zplediag(1) 
-          zb2   = zplediag(2) - zpiv1 * zsupdiag(1)
-          zd2   = zsmbr(2) - zpiv1 * zsmbr(1)
-
-          zpiv2 = zsubdiag(3) / zb2
-          zb3   = zplediag(3) - zpiv2 * zsupdiag(2)
-          zd3   = zsmbr(3) - zpiv2 * zd2
-
-          tbif_1d(ji,3) = zd3 / zb3
-          tbif_1d(ji,2) = ( zd2 - zsupdiag(2) * tbif_1d(ji,3) ) / zb2
-          tbif_1d(ji,1) = ( zsmbr(1) - zsupdiag(1) * tbif_1d(ji,2) ) / zplediag(1)            
-
-          !--- taking into account the particular case of  zidsnic(ji) = 1
-          ztint =  (  zkic(ji) * h_snow_1d(ji) * tfu_1d (ji)    &
-             &      + zksn(ji) * h_ice_1d(ji) * sist_1d(ji) )   &
-             &   / ( zkic(ji) * h_snow_1d(ji) + zksn(ji) * h_ice_1d(ji) ) 
-
-          tbif_1d(ji,1) = ( 1.0 - zidsnic(ji) ) * tbif_1d(ji,1)   &
-             &                + zidsnic(ji)   * ( ztint + sist_1d(ji) ) / 2.0
-          tbif_1d(ji,2) = ( 1.0 - zidsnic(ji) ) * tbif_1d(ji,2)   &
-             &                + zidsnic(ji)   * ( 3.0 * ztint + tfu_1d(ji) ) / 4.0
-          tbif_1d(ji,3) = ( 1.0 - zidsnic(ji) ) * tbif_1d(ji,3)   &
-             &                + zidsnic(ji)   * ( ztint + 3.0 * tfu_1d(ji) ) / 4.0     
-       END DO
+         zsmbr(1) = zidsn(ji) * sist_1d(ji) + z1midsn(ji) *    &
+            &       ( h_snow_1d(ji) * tbif_1d(ji,1) - ( zfcsudt(ji) / rcpsn )  &
+            &       - zumsb * zkhsnint * ( tbif_1d(ji,1) - tbif_1d(ji,2) ) )
+
+         zsmbr(2) =  tbif_1d(ji,2)  &
+            &      - zidsn(ji) * ( 1.0 - zidsnic(ji) ) &
+            &        * ( zfcsudt(ji) / MAX( h_ice_1d(ji) * rcpic , epsi20 ) ) &
+            &      + zumsb * ( zkhicint * ( tbif_1d(ji,1) - tbif_1d(ji,2) ) &
+            &                   - zkhic * ( tbif_1d(ji,2) - tbif_1d(ji,3) )  )
+
+         zsmbr(3) =  tbif_1d(ji,3)  &
+            &      + zkhic * ( 2.0 * tfu_1d(ji) &
+            &                + zumsb * ( tbif_1d(ji,2) - 3.0 * tbif_1d(ji,3) ) )
+          
+         !     6.4. Solve the system (Gauss elimination method).
+         !----------------------------------------------------
+          
+         zpiv1 = zsubdiag(2) / zplediag(1) 
+         zb2   = zplediag(2) - zpiv1 * zsupdiag(1)
+         zd2   = zsmbr(2) - zpiv1 * zsmbr(1)
+
+         zpiv2 = zsubdiag(3) / zb2
+         zb3   = zplediag(3) - zpiv2 * zsupdiag(2)
+         zd3   = zsmbr(3) - zpiv2 * zd2
+
+         tbif_1d(ji,3) = zd3 / zb3
+         tbif_1d(ji,2) = ( zd2 - zsupdiag(2) * tbif_1d(ji,3) ) / zb2
+         tbif_1d(ji,1) = ( zsmbr(1) - zsupdiag(1) * tbif_1d(ji,2) ) / zplediag(1)            
+
+         !--- taking into account the particular case of  zidsnic(ji) = 1
+         ztint =  (  zkic(ji) * h_snow_1d(ji) * tfu_1d (ji)    &
+            &      + zksn(ji) * h_ice_1d(ji) * sist_1d(ji) )   &
+            &   / ( zkic(ji) * h_snow_1d(ji) + zksn(ji) * h_ice_1d(ji) ) 
+
+         tbif_1d(ji,1) = ( 1.0 - zidsnic(ji) ) * tbif_1d(ji,1)   &
+            &                + zidsnic(ji)   * ( ztint + sist_1d(ji) ) / 2.0
+         tbif_1d(ji,2) = ( 1.0 - zidsnic(ji) ) * tbif_1d(ji,2)   &
+            &                + zidsnic(ji)   * ( 3.0 * ztint + tfu_1d(ji) ) / 4.0
+         tbif_1d(ji,3) = ( 1.0 - zidsnic(ji) ) * tbif_1d(ji,3)   &
+            &                + zidsnic(ji)   * ( ztint + 3.0 * tfu_1d(ji) ) / 4.0     
+      END DO
  
-       !----------------------------------------------------------------------
-       !  9. Take into account surface ablation and bottom accretion-ablation.|
-       !----------------------------------------------------------------------
+      !----------------------------------------------------------------------
+      !  9. Take into account surface ablation and bottom accretion-ablation.|
+      !----------------------------------------------------------------------
        
-       !---Snow accumulation in one thermodynamic time step
-       zsprecip(kideb:kiut) = sprecip_1d(kideb:kiut) * rdt_ice / rhosn
-
-
-       DO ji = kideb, kiut
-          
-          !      9.1. Surface ablation and update of snow thickness and qstbif_1d
-          !--------------------------------------------------------------------
+      !---Snow accumulation in one thermodynamic time step
+      zsprecip(kideb:kiut) = sprecip_1d(kideb:kiut) * rdt_ice / rhosn
+
+
+      DO ji = kideb, kiut
+          
+         !      9.1. Surface ablation and update of snow thickness and qstbif_1d
+         !--------------------------------------------------------------------
           
           !--------------------------------------------------------------------------
@@ -759,8 +752,8 @@
           qstbif_1d(ji) = zdrfrl2 * qstbif_1d(ji)
           frld_1d(ji)    = zfrld_1d(ji)
-          !
-       END DO
-       ! 
-    END SUBROUTINE lim_thd_zdf_2
+         !
+      END DO
+      ! 
+   END SUBROUTINE lim_thd_zdf_2
 
 #else
@@ -768,7 +761,4 @@
    !!   Default Option                                     NO sea-ice model
    !!----------------------------------------------------------------------
-CONTAINS
-   SUBROUTINE lim_thd_zdf_2          ! Empty routine
-   END SUBROUTINE lim_thd_zdf_2
 #endif
 
Index: /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/LIM_SRC_2/limtrp_2.F90
===================================================================
--- /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/LIM_SRC_2/limtrp_2.F90	(revision 1854)
+++ /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/LIM_SRC_2/limtrp_2.F90	(revision 1855)
@@ -4,4 +4,8 @@
    !! LIM 2.0 transport ice model : sea-ice advection/diffusion
    !!======================================================================
+   !! History :  LIM  ! 2000-01 (LIM)  Original code
+   !!            1.0  ! 2001-05 (G. Madec, R. Hordoir) opa norm
+   !!            2.0  ! 2004-01 (G. Madec, C. Ethe)  F90, mpp
+   !!----------------------------------------------------------------------
 #if defined key_lim2
    !!----------------------------------------------------------------------
@@ -11,5 +15,4 @@
    !!   lim_trp_init_2 : initialization and namelist read
    !!----------------------------------------------------------------------
-   !! * Modules used
    USE phycst
    USE dom_oce
@@ -26,25 +29,20 @@
    PRIVATE
 
-   !! * Routine accessibility
-   PUBLIC lim_trp_2     ! called by sbc_ice_lim_2
-
-   !! * Shared module variables
-   REAL(wp), PUBLIC  ::   &  !:
-      bound  = 0.e0          !: boundary condit. (0.0 no-slip, 1.0 free-slip)
-
-   !! * Module variables
-   REAL(wp)  ::           &  ! constant values
-      epsi06 = 1.e-06  ,  &
-      epsi03 = 1.e-03  ,  &
-      epsi16 = 1.e-16  ,  &
-      rzero  = 0.e0    ,  &
-      rone   = 1.e0
+   PUBLIC   lim_trp_2   ! called by sbc_ice_lim_2
+
+   REAL(wp), PUBLIC  ::   bound  = 0.e0   !: boundary condit. (0.0 no-slip, 1.0 free-slip)
+
+   REAL(wp) ::   epsi06 = 1.e-06   ! constant values
+   REAL(wp) ::   epsi03 = 1.e-03   !
+   REAL(wp) ::   epsi16 = 1.e-16   !
+   REAL(wp) ::   rzero  = 0.e0     !
+   REAL(wp) ::   rone   = 1.e0     !
 
    !! * Substitution
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !!   LIM 2.0,  UCL-LOCEAN-IPSL (2005) 
+   !! NEMO/LIM 3.3,  UCL-LOCEAN-IPSL (2010) 
    !! $Id$
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -62,34 +60,13 @@
       !!
       !! ** action :
-      !!
-      !! History :
-      !!   1.0  !  00-01 (LIM)  Original code
-      !!        !  01-05 (G. Madec, R. Hordoir) opa norm
-      !!   2.0  !  04-01 (G. Madec, C. Ethe)  F90, mpp
       !!---------------------------------------------------------------------
       INTEGER, INTENT(in) ::   kt     ! number of iteration
-
-      INTEGER  ::   ji, jj, jk,   &  ! dummy loop indices
-         &          initad           ! number of sub-timestep for the advection
-
-      REAL(wp) ::  &                              
-         zindb  ,  &
-         zacrith, &
-         zindsn , &
-         zindic , &
-         zusvosn, &
-         zusvoic, &
-         zignm  , &
-         zindhe , &
-         zvbord , &
-         zcfl   , &
-         zusnit , &
-         zrtt, ztsn, ztic1, ztic2
-
-      REAL(wp), DIMENSION(jpi,jpj)  ::   &  ! temporary workspace
-         zui_u , zvi_v , zsm   ,         &
-         zs0ice, zs0sn , zs0a  ,         &
-         zs0c0 , zs0c1 , zs0c2 ,         &
-         zs0st
+      !!
+      INTEGER  ::   ji, jj, jk   ! dummy loop indices
+      INTEGER  ::   initad       ! number of sub-timestep for the advection
+      REAL(wp) ::   zindb , zacrith, zindsn , zignm , zvbord, zrtt, ztic1, zusnit
+      REAL(wp) ::   zindic, zusvosn, zusvoic, zindhe, zcfl  , ztsn, ztic2
+      REAL(wp), DIMENSION(jpi,jpj) ::   zui_u , zs0sn, zs0c0, zs0a , zsm      ! 2D workspace
+      REAL(wp), DIMENSION(jpi,jpj) ::   zvi_v , zs0st, zs0c1, zs0c2, zs0ice   !  -      -
       !---------------------------------------------------------------------
 
@@ -98,8 +75,7 @@
       zsm(:,:) = area(:,:)
       
-      IF( ln_limdyn ) THEN
-         !-------------------------------------!
-         !   Advection of sea ice properties   !
-         !-------------------------------------!
+      !                             !-------------------------------------!
+      IF( ln_limdyn ) THEN          !   Advection of sea ice properties   !
+         !                          !-------------------------------------!
 
          ! ice velocities at ocean U- and V-points (zui_u,zvi_v)
@@ -113,7 +89,5 @@
             END DO
          END DO
-         ! Lateral boundary conditions on zui_u, zvi_v
-         CALL lbc_lnk( zui_u, 'U', -1. )
-         CALL lbc_lnk( zvi_v, 'V', -1. )
+         CALL lbc_lnk( zui_u, 'U', -1. )   ;   CALL lbc_lnk( zvi_v, 'V', -1. )         ! Lateral boundary conditions
 
          ! CFL test for stability
@@ -123,7 +97,7 @@
          zcfl  = MAX( zcfl, MAXVAL( ABS( zvi_v( :     ,1:jpjm1) ) * rdt_ice / e2v( :     ,1:jpjm1) ) )
 
-         IF (lk_mpp ) CALL mpp_max(zcfl)
-
-         IF ( zcfl > 0.5 .AND. lwp )   WRITE(numout,*) 'lim_trp_2 : violation of cfl criterion the ',nday,'th day, cfl = ',zcfl
+         IF( lk_mpp ) CALL mpp_max( zcfl )
+
+         IF( zcfl > 0.5 .AND. lwp )   WRITE(numout,*) 'lim_trp_2 : CFL violation at the ',nday,'th day, cfl = ',zcfl
 
          ! content of properties
@@ -144,5 +118,5 @@
          zusnit = 1.0 / REAL( initad ) 
          
-         IF ( MOD( nday , 2 ) == 0) THEN
+         IF( MOD( nday , 2 ) == 0) THEN
             DO jk = 1,initad
                CALL lim_adv_x_2( zusnit, zui_u, rone , zsm, zs0ice, sxice, sxxice, syice, syyice, sxyice )
@@ -228,12 +202,8 @@
          !   Up-dating and limitation of sea ice properties after transport   !
          ! -------------------------------------------------------------------!
-
-         ! Up-dating and limitation of sea ice properties after transport.
          DO jj = 1, jpj
-!!!iii      zindhe = REAL( MAX( 0, isign(1, jj - njeq ) ) )              !ibug mpp  !!bugmpp  njeq!
             zindhe = MAX( 0.e0, SIGN( 1.e0, fcor(1,jj) ) )              ! = 0 for SH, =1 for NH
             DO ji = 1, jpi
-
-               ! Recover mean values over the grid squares.
+               !                                                        ! Recover mean values over the grid squares.
                zs0sn (ji,jj) = MAX( rzero, zs0sn (ji,jj)/area(ji,jj) )
                zs0ice(ji,jj) = MAX( rzero, zs0ice(ji,jj)/area(ji,jj) )
@@ -243,6 +213,5 @@
                zs0c2 (ji,jj) = MAX( rzero, zs0c2 (ji,jj)/area(ji,jj) )
                zs0st (ji,jj) = MAX( rzero, zs0st (ji,jj)/area(ji,jj) )
-
-               ! Recover in situ values.
+               !                                                        ! Recover in situ values.
                zindb         = MAX( rzero, SIGN( rone, zs0a(ji,jj) - epsi06 ) )
                zacrith       = 1.0 - ( zindhe * acrit(1) + ( 1.0 - zindhe ) * acrit(2) )
@@ -262,8 +231,8 @@
                zrtt          = 173.15 * rone 
                ztsn          =          zignm   * tbif(ji,jj,1)  &
-                              + ( 1.0 - zignm ) * MIN( MAX( zrtt, rt0_snow * zusvosn * zs0c0(ji,jj)) , tfu(ji,jj) ) 
+                  &           + ( 1.0 - zignm ) * MIN( MAX( zrtt, rt0_snow * zusvosn * zs0c0(ji,jj)) , tfu(ji,jj) ) 
                ztic1          = MIN( MAX( zrtt, rt0_ice * zusvoic * zs0c1(ji,jj) ) , tfu(ji,jj) )
                ztic2          = MIN( MAX( zrtt, rt0_ice * zusvoic * zs0c2(ji,jj) ) , tfu(ji,jj) )
- 
+               !
                tbif(ji,jj,1) = zindsn * ztsn  + ( 1.0 - zindsn ) * tfu(ji,jj)               
                tbif(ji,jj,2) = zindic * ztic1 + ( 1.0 - zindic ) * tfu(ji,jj)
@@ -272,7 +241,7 @@
             END DO
          END DO
-         
+         !
       ENDIF
-      
+      !
    END SUBROUTINE lim_trp_2
 
@@ -288,15 +257,11 @@
       !!
       !! ** input   :   Namelist namicetrp
-      !!
-      !! history :
-      !!   2.0  !  03-08 (C. Ethe)  Original code
       !!-------------------------------------------------------------------
       NAMELIST/namicetrp/ bound
       !!-------------------------------------------------------------------
-
-      ! Read Namelist namicetrp
-      REWIND ( numnam_ice )
+      !
+      REWIND ( numnam_ice )                  ! Read Namelist namicetrp
       READ   ( numnam_ice  , namicetrp )
-      IF(lwp) THEN
+      IF(lwp) THEN                           ! control print
          WRITE(numout,*)
          WRITE(numout,*) 'lim_trp_init_2 : Ice parameters for advection '
@@ -304,5 +269,5 @@
          WRITE(numout,*) '   boundary conditions (0. no-slip, 1. free-slip) bound  = ', bound
       ENDIF
-            
+      ! 
    END SUBROUTINE lim_trp_init_2
 
@@ -311,7 +276,4 @@
    !!   Default option         Empty Module                No sea-ice model
    !!----------------------------------------------------------------------
-CONTAINS
-   SUBROUTINE lim_trp_2        ! Empty routine
-   END SUBROUTINE lim_trp_2
 #endif
 
Index: /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/LIM_SRC_2/limwri_2.F90
===================================================================
--- /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/LIM_SRC_2/limwri_2.F90	(revision 1854)
+++ /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/LIM_SRC_2/limwri_2.F90	(revision 1855)
@@ -12,10 +12,7 @@
    !!   'key_lim2'                                    LIM 2.0 sea-ice model
    !!----------------------------------------------------------------------
-   !!----------------------------------------------------------------------
-   !!   lim_wri_2      : write of the diagnostics variables in ouput file 
-   !!   lim_wri_init_2 : initialization and namelist read
-   !!   lim_wri_state_2 : write for initial state or/and abandon:
-   !!                     > output.init.nc (if ninist = 1 in namelist)
-   !!                     > output.abort.nc
+   !!   lim_wri_2       : write of the diagnostics variables in ouput file 
+   !!   lim_wri_init_2  : initialization and namelist read
+   !!   lim_wri_state_2 : write for initial state (output.init.nc if ninist=1) or/and in the abort file
    !!----------------------------------------------------------------------
    USE phycst
@@ -42,6 +39,6 @@
    INTEGER, PARAMETER                       ::   jpnoumax = 40   ! maximum number of variable for ice output
    INTEGER                                  ::   noumef          ! number of fields
-   REAL(wp)           , DIMENSION(jpnoumax) ::   cmulti ,     &  ! multiplicative constant
-      &                                          cadd            ! additive constant
+   REAL(wp)           , DIMENSION(jpnoumax) ::   cmulti         ! multiplicative constant
+   REAL(wp)           , DIMENSION(jpnoumax) ::   cadd            ! additive constant
    CHARACTER(len = 35), DIMENSION(jpnoumax) ::   titn            ! title of the field
    CHARACTER(len = 8 ), DIMENSION(jpnoumax) ::   nam             ! name of the field
@@ -52,13 +49,12 @@
    INTEGER , DIMENSION( jpij ) ::   ndex51              ! ????
 
-   REAL(wp)  ::            &  ! constant values
-      epsi16 = 1.e-16   ,  &
-      zzero  = 0.e0     ,  &
-      zone   = 1.e0
+   REAL(wp) ::   epsi16 = 1.e-16   ! constant values
+   REAL(wp) ::   rzero  = 0.e0     !
+   REAL(wp) ::   rone   = 1.e0     !
 
    !! * Substitutions
 #   include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !!  LIM 2.0, UCL-LOCEAN-IPSL (2006)
+   !! NEMO/LIM 3.3,  UCL-LOCEAN-IPSL (2010) 
    !! $Id$
    !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
@@ -81,14 +77,13 @@
       !!
       !! ** Method  :   computes the average of some variables and write
-      !!      it in the NetCDF ouput files
-      !!      CAUTION: the sea-ice time-step must be an integer fraction
-      !!      of a day
+      !!              it in the NetCDF ouput files
+      !! CAUTION: the sea-ice time-step must be an integer fraction of a day
       !!-------------------------------------------------------------------
       INTEGER, INTENT(in) ::   kt     ! number of iteration
       !!
-      INTEGER  ::   ji, jj, jf                      ! dummy loop indices
+      INTEGER  ::   ji, jj, jf   ! dummy loop indices
       CHARACTER(len = 40)  ::   clhstnam, clop
-      REAL(wp) ::   zsto, zjulian, zout,   &  ! temporary scalars
-         &          zindh, zinda, zindb, ztmu
+      REAL(wp) ::   zsto, zjulian, zout          ! temporary scalars
+      REAL(wp) ::   zindh, zinda, zindb, ztmu
       REAL(wp), DIMENSION(1)                ::   zdept
       REAL(wp), DIMENSION(jpi,jpj)          ::   zfield
@@ -132,8 +127,8 @@
       DO jj = 2 , jpjm1
          DO ji = 1 , jpim1   ! NO vector opt.
-            zindh  = MAX( zzero , SIGN( zone , hicif(ji,jj) * (1.0 - frld(ji,jj) ) - 0.10 ) )
-            zinda  = MAX( zzero , SIGN( zone , ( 1.0 - frld(ji,jj) ) - 0.10 ) )
+            zindh  = MAX( rzero , SIGN( rone , hicif(ji,jj) * (1.0 - frld(ji,jj) ) - 0.10 ) )
+            zinda  = MAX( rzero , SIGN( rone , ( 1.0 - frld(ji,jj) ) - 0.10 ) )
             zindb  = zindh * zinda
-            ztmu   = MAX( 0.5 * zone , ( tmu(ji,jj) + tmu(ji+1,jj) + tmu(ji,jj+1) + tmu(ji+1,jj+1) ) ) 
+            ztmu   = MAX( 0.5 * rone , ( tmu(ji,jj) + tmu(ji+1,jj) + tmu(ji,jj+1) + tmu(ji+1,jj+1) ) ) 
             zcmo(ji,jj,1)  = hsnif (ji,jj)
             zcmo(ji,jj,2)  = hicif (ji,jj)
@@ -143,10 +138,10 @@
             zcmo(ji,jj,6)  = fbif  (ji,jj)
             zcmo(ji,jj,7)  = zindb * (  u_ice(ji,jj  ) * tmu(ji,jj  ) + u_ice(ji+1,jj  ) * tmu(ji+1,jj  )   &
-                                      + u_ice(ji,jj+1) * tmu(ji,jj+1) + u_ice(ji+1,jj+1) * tmu(ji+1,jj+1) ) &
-                                  / ztmu 
+               &                      + u_ice(ji,jj+1) * tmu(ji,jj+1) + u_ice(ji+1,jj+1) * tmu(ji+1,jj+1) ) &
+               &                  / ztmu 
 
             zcmo(ji,jj,8)  = zindb * (  v_ice(ji,jj  ) * tmu(ji,jj  ) + v_ice(ji+1,jj  ) * tmu(ji+1,jj  )   &
-                                      + v_ice(ji,jj+1) * tmu(ji,jj+1) + v_ice(ji+1,jj+1) * tmu(ji+1,jj+1) ) &
-                                  / ztmu
+               &                      + v_ice(ji,jj+1) * tmu(ji,jj+1) + v_ice(ji+1,jj+1) * tmu(ji+1,jj+1) ) &
+               &                  / ztmu
             zcmo(ji,jj,9)  = sst_m(ji,jj)
             zcmo(ji,jj,10) = sss_m(ji,jj)
@@ -200,5 +195,5 @@
       !! ** input   :   Namelist namicewri
       !!-------------------------------------------------------------------
-      INTEGER ::   nf      ! ???
+      INTEGER ::   jf      ! dummy loop indices
       TYPE FIELD 
          CHARACTER(len = 35) :: ztitle 
@@ -209,16 +204,13 @@
          REAL                :: zcadd        
       END TYPE FIELD
-      TYPE(FIELD) ::  &
-         field_1 , field_2 , field_3 , field_4 , field_5 , field_6 ,   &
-         field_7 , field_8 , field_9 , field_10, field_11, field_12,   &
-         field_13, field_14, field_15, field_16, field_17, field_18,   &
-         field_19
+      TYPE(FIELD) ::   field_1 , field_2 , field_3 , field_4 , field_5 , field_6  
+      TYPE(FIELD) ::   field_7 , field_8 , field_9 , field_10, field_11, field_12
+      TYPE(FIELD) ::   field_13, field_14, field_15, field_16, field_17, field_18, field_19
       TYPE(FIELD) , DIMENSION(jpnoumax) :: zfield
-
-      NAMELIST/namiceout/ noumef, &
-         field_1 , field_2 , field_3 , field_4 , field_5 , field_6 ,   &
-         field_7 , field_8 , field_9 , field_10, field_11, field_12,   &
-         field_13, field_14, field_15, field_16, field_17, field_18,   &
-         field_19
+      !!
+      NAMELIST/namiceout/ noumef,                                          &
+         field_1 , field_2 , field_3 , field_4 , field_5 , field_6 ,       &
+         field_7 , field_8 , field_9 , field_10, field_11, field_12,       &
+         field_13, field_14, field_15, field_16, field_17, field_18, field_19
       !!-------------------------------------------------------------------
 
@@ -246,11 +238,11 @@
       zfield(19) = field_19
       
-      DO nf = 1, noumef
-         titn  (nf) = zfield(nf)%ztitle
-         nam   (nf) = zfield(nf)%zname
-         uni   (nf) = zfield(nf)%zunit
-         nc    (nf) = zfield(nf)%znc
-         cmulti(nf) = zfield(nf)%zcmulti
-         cadd  (nf) = zfield(nf)%zcadd
+      DO jf = 1, noumef
+         titn  (jf) = zfield(jf)%ztitle
+         nam   (jf) = zfield(jf)%zname
+         uni   (jf) = zfield(jf)%zunit
+         nc    (jf) = zfield(jf)%znc
+         cmulti(jf) = zfield(jf)%zcmulti
+         cadd  (jf) = zfield(jf)%zcadd
       END DO
 
@@ -262,7 +254,7 @@
          WRITE(numout,*) '           title                            name     unit      Saving (1/0) ',   &
             &            '    multiplicative constant       additive constant '
-         DO nf = 1 , noumef         
-            WRITE(numout,*) '   ', titn(nf), '   ', nam(nf),'      ', uni(nf),'  ', nc(nf),'        ', cmulti(nf),   &
-               &       '        ', cadd(nf)
+         DO jf = 1 , noumef         
+            WRITE(numout,*) '   ', titn(jf), '   ', nam(jf),'      ', uni(jf),'  ', nc(jf),'        ', cmulti(jf),   &
+               &       '        ', cadd(jf)
          END DO
       ENDIF
@@ -281,7 +273,4 @@
       !!        Used to find errors in the initial state or save the last
       !!      ocean state in case of abnormal end of a simulation
-      !!
-      !! History :
-      !!   2.0  !  2009-06  (B. Lemaire)
       !!----------------------------------------------------------------------
       INTEGER, INTENT( in ) ::   kt               ! ocean time-step index)
Index: /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/LIM_SRC_3/limtab.F90
===================================================================
--- /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/LIM_SRC_3/limtab.F90	(revision 1854)
+++ /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/LIM_SRC_3/limtab.F90	(revision 1855)
@@ -2,14 +2,13 @@
    !!======================================================================
    !!                       ***  MODULE limtab   ***
-   !!              transform 1D (2D) array to a 2D (1D) table
+   !!   LIM-3 ice model : transform 1D (2D) array to a 2D (1D) array
    !!======================================================================
 #if defined key_lim3
    !!----------------------------------------------------------------------
-   !!   'key_lim3'                                      LIM3 sea-ice model
+   !!   'key_lim3' :                                  LIM 2.0 sea-ice model
    !!----------------------------------------------------------------------
    !!   tab_2d_1d  : 2-D to 1-D
    !!   tab_1d_2d  : 1-D to 2-D
    !!----------------------------------------------------------------------
-   !! * Modules used
    USE par_kind
 
@@ -17,10 +16,9 @@
    PRIVATE
 
-   !! * Routine accessibility
-   PUBLIC tab_2d_1d  ! called by lim_ther
-   PUBLIC tab_1d_2d  ! called by lim_ther
+   PUBLIC   tab_2d_1d   ! called by lim_thd
+   PUBLIC   tab_1d_2d   ! called by lim_thd
 
    !!----------------------------------------------------------------------
-   !!   LIM 3.0,  UCL-ASTR-LOCEAN-IPSL (2008) 
+   !! NEMO/LIM 3.3,  UCL-LOCEAN-IPSL (2010) 
    !! $Id$
    !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
@@ -28,55 +26,49 @@
 CONTAINS
 
-   SUBROUTINE tab_2d_1d ( ndim1d, tab1d, tab2d, ndim2d_x, ndim2d_y, tab_ind )
-
-      INTEGER, INTENT(in) :: &
-         ndim1d, ndim2d_x, ndim2d_y
-
-      REAL(wp), DIMENSION (ndim2d_x, ndim2d_y), INTENT(in) ::  &
-         tab2d
-
-      INTEGER, DIMENSION ( ndim1d), INTENT ( in) :: &
-         tab_ind
-
-      REAL(wp), DIMENSION(ndim1d), INTENT ( out) ::  & 
-         tab1d
-
-      INTEGER ::  &
-         jn , jid, jjd
-
-      DO jn = 1, ndim1d
-         jid        = MOD( tab_ind(jn) - 1, ndim2d_x ) + 1
-         jjd        = ( tab_ind(jn) - 1 ) / ndim2d_x + 1
-         tab1d( jn) = tab2d( jid, jjd)
-      END DO
-
+   SUBROUTINE tab_2d_1d( kdim1d, ptab1d, ptab2d, kdim2d_i, kdim2d_j, ptab_ind )
+      !!-------------------------------------------------------------------
+      INTEGER , INTENT(in   )                                ::   kdim1d
+      INTEGER , INTENT(in   )                                ::   kdim2d_i, kdim2d_j
+      REAL(wp), INTENT(in   ), DIMENSION(kdim2d_i, kdim2d_j) ::   ptab2d
+      INTEGER , INTENT(in   ), DIMENSION(kdim1d)             ::   ptab_ind
+      REAL(wp), INTENT(  out), DIMENSION(kdim1d)             ::   ptab1d
+      !!
+      INTEGER ::   jn , jid, jjd   ! dummy loop indices
+      !!-------------------------------------------------------------------
+      ! 
+      DO jn = 1, kdim1d
+         jid = MOD( ptab_ind(jn) - 1, kdim2d_i ) + 1
+         jjd = ( ptab_ind(jn) - 1 ) / kdim2d_i + 1
+         ptab1d(jn) = ptab2d(jid,jjd)
+      END DO 
+      !
    END SUBROUTINE tab_2d_1d
 
 
-   SUBROUTINE tab_1d_2d ( ndim1d, tab2d, tab_ind, tab1d, ndim2d_x, ndim2d_y )
-
-      INTEGER, INTENT ( in) :: &
-         ndim1d, ndim2d_x, ndim2d_y
-
-      INTEGER, DIMENSION (ndim1d) , INTENT (in) :: &
-         tab_ind
-
-      REAL(wp), DIMENSION(ndim1d), INTENT (in) ::  &
-         tab1d  
-
-      REAL(wp), DIMENSION (ndim2d_x, ndim2d_y), INTENT ( out) :: &
-         tab2d
-
-      INTEGER :: &
-         jn, jid, jjd
-
-      DO jn = 1, ndim1d
-         jid             = MOD( tab_ind(jn) - 1, ndim2d_x) + 1
-         jjd             =    ( tab_ind(jn) - 1 ) / ndim2d_x  + 1
-         tab2d(jid, jjd) = tab1d( jn)
+   SUBROUTINE tab_1d_2d( kdim1d, ptab2d, ptab_ind, ptab1d, kdim2d_i, kdim2d_j )
+      !!-------------------------------------------------------------------
+      INTEGER , INTENT(in   )                                ::   kdim1d
+      INTEGER , INTENT(in   )                                ::   kdim2d_i, kdim2d_j
+      INTEGER , INTENT(in   ), DIMENSION(kdim1d)             ::   ptab_ind
+      REAL(wp), INTENT(in   ), DIMENSION(kdim1d)             ::   ptab1d
+      REAL(wp), INTENT(  out), DIMENSION(kdim2d_i, kdim2d_j) ::   ptab2d
+      !!
+      INTEGER ::   jn, jid, jjd   ! dummy loop indices
+      !!-------------------------------------------------------------------
+      !
+      DO jn = 1, kdim1d
+         jid = MOD( ptab_ind(jn) - 1, kdim2d_i) + 1
+         jjd =    ( ptab_ind(jn) - 1 ) / kdim2d_i  + 1
+         ptab2d(jid,jjd) = ptab1d(jn)
       END DO
-
+      !
    END SUBROUTINE tab_1d_2d
 
+#else
+   !!----------------------------------------------------------------------
+   !!   Default option          Dummy module       NO LIM 2.0 sea-ice model
+   !!----------------------------------------------------------------------
 #endif
+
+   !!======================================================================
 END MODULE limtab
